#ifndef EFL_GENERATED_EVAS_3D_MESH_HH
#define EFL_GENERATED_EVAS_3D_MESH_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_3d_mesh.eo.h"
}

#include "evas_3d_object.eo.hh"
#include "evas_common_interface.eo.hh"
#include <string>

struct evas_3d_mesh
      : evas_3d_object,
      efl::eo::detail::extension_inheritance<evas::common_interface>::template type< ::evas_3d_mesh>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit evas_3d_mesh(Eo* eo)
      : evas_3d_object(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit evas_3d_mesh(std::nullptr_t)
      : evas_3d_object(nullptr)
   {}

   /// @brief Call the object's constructor.
   /// Should not be used with #eo_do. Only use it with #eo_do_super.
   ///
   evas_3d_mesh(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : evas_3d_mesh(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   evas_3d_mesh(evas_3d_mesh const& other)
      : evas_3d_object(eo_ref(other._eo_ptr()))
   {}

   ~evas_3d_mesh() {}

   /// @brief Pure virtual update_notify function..
   /// Update request for the object.
   ///
   void update_notify() const
   {
      eo_do(_eo_ptr(), ::evas_3d_object_update_notify());
   }

   /// @brief Pure virtual change_notify function..
   /// Update request for the object.
   ///
   /// @param state State that is changed
   /// @param ref The Object that caused the change
   ///
   void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_object_change_notify(state_, ref_));
   }

   /// @param mode The shade mode.
   ///
   Evas_3D_Shade_Mode shade_mode_get() const
   {
      Evas_3D_Shade_Mode _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_mesh_shade_mode_get());
      return _tmp_ret;
   }

   /// @param mode The shade mode.
   ///
   void shade_mode_set(Evas_3D_Shade_Mode mode_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_shade_mode_set(mode_));
   }

   /// @param material The material to be set to the key frame.
   ///
   Evas_3D_Material * frame_material_get(int frame_) const
   {
      Evas_3D_Material * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_mesh_frame_material_get(frame_));
      return _tmp_ret;
   }

   /// @param material The material to be set to the key frame.
   ///
   void frame_material_set(int frame_, Evas_3D_Material * material_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_frame_material_set(frame_, material_));
   }

   /// @param assembly Vertex assembly.
   ///
   Evas_3D_Vertex_Assembly vertex_assembly_get() const
   {
      Evas_3D_Vertex_Assembly _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_mesh_vertex_assembly_get());
      return _tmp_ret;
   }

   /// @param assembly Vertex assembly.
   ///
   void vertex_assembly_set(Evas_3D_Vertex_Assembly assembly_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_vertex_assembly_set(assembly_));
   }

   /// @param type The type of the mesh file.
   /// @param file Path to the mesh file.
   /// @param key Key in the mesh file.
   ///
   void file_set(Evas_3D_Mesh_File_Type type_, std::string file_, std::string key_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_file_set(type_, efl::eolian::to_c(file_), efl::eolian::to_c(key_)));
   }

   /// @param type The type of the mesh file.
   /// @param file Path to the mesh file.
   /// @param key Key in the mesh file.
   ///
   void save(Evas_3D_Mesh_File_Type type_, std::string file_, std::string key_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_save(type_, efl::eolian::to_c(file_), efl::eolian::to_c(key_)));
   }

   /// @brief Set the vertex data of the key frame of the given mesh.
   ///
   /// This function make evas read from the given buffer whenever it requires.
   /// If you want to release the buffer after calling this functions, use
   /// evas_3d_mesh_frame_vertex_data_copy_set() instead.
   ///
   /// After setting the vertex data, further modifications should be protected
   /// by map/unmap pair.
   ///
   /// @see evas_3d_mesh_frame_vertex_data_copy_set()
   /// @see evas_3d_mesh_frame_vertex_data_map()
   /// @see evas_3d_mesh_frame_vertex_data_unmap()
   ///
   /// @ingroup Evas_3D_Mesh
   ///
   /// @param frame The number of the key frame.
   /// @param attrib Vertex attribute ID.
   /// @param stride Stride to go to the next vertex (in bytes).
   /// @param data Pointer to the vertex data buffer.
   ///
   void frame_vertex_data_set(int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_frame_vertex_data_set(frame_, attrib_, stride_, data_));
   }

   /// @brief Set the vertex data of the key frame of the given mesh by copying from a buffer.
   /// This function allocates internal vertex buffer and copy from the given
   /// buffer. So you can release the buffer. If you want to modify the vertex data
   /// use evas_3d_mesh_frame_vertex_data_map(). After finishing the modifications,
   /// you should call evas_3d_mesh_frame_vertex_data_unmap().
   ///
   /// @see evas_3d_mesh_frame_vertex_data_set()
   /// @see evas_3d_mesh_frame_vertex_data_map()
   /// @see evas_3d_mesh_frame_vertex_data_unmap()
   ///
   /// @ingroup Evas_3D_Mesh
   ///
   /// @param frame The number of the key frame.
   /// @param attrib Vertex attribute ID.
   /// @param stride Stride to go to the next vertex (in bytes).
   /// @param data Pointer to the vertex data buffer.
   ///
   void frame_vertex_data_copy_set(int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_frame_vertex_data_copy_set(frame_, attrib_, stride_, data_));
   }

   /// @brief Map the vertex buffer of the key frame of the given mesh.
   ///
   /// After manipulating the mapped buffer, evas_3d_mesh_frame_vertex_data_unmap()
   /// should be called to properly download the data to the engine. If the data
   /// was set using evas_3d_mesh_frame_vertex_data_set(), pointer to the original
   /// buffer will be returned. Otherwise, the returned pointer can differ every
   /// time calling this function.
   ///
   /// @see evas_3d_mesh_frame_vertex_data_unmap()
   /// @return Starting address of the mapped vertex buffer.
   ///
   /// @ingroup Evas_3D_Mesh
   ///
   /// @param frame The number of the key frame.
   /// @param attrib Vertex attribute ID.
   ///
   void * frame_vertex_data_map(int frame_, Evas_3D_Vertex_Attrib attrib_) const
   {
      void * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_mesh_frame_vertex_data_map(frame_, attrib_));
      return _tmp_ret;
   }

   /// @param frame The number of the key frame.
   /// @param attrib Vertex attribute ID.
   ///
   void frame_vertex_data_unmap(int frame_, Evas_3D_Vertex_Attrib attrib_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_frame_vertex_data_unmap(frame_, attrib_));
   }

   /// @param frame The number of the key frame.
   /// @param attrib Vertex attribute ID.
   ///
   int frame_vertex_stride_get(int frame_, Evas_3D_Vertex_Attrib attrib_) const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_mesh_frame_vertex_stride_get(frame_, attrib_));
      return _tmp_ret;
   }

   /// @param format Vertex index data format.
   /// @param count Vertex index count.
   /// @param indices Pointer to the index data.
   ///
   void index_data_set(Evas_3D_Index_Format format_, int count_, const void * indices_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_index_data_set(format_, count_, indices_));
   }

   /// @param format Vertex index data format.
   /// @param count Vertex index count.
   /// @param indices Pointer to the index data.
   ///
   void index_data_copy_set(Evas_3D_Index_Format format_, int count_, const void * indices_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_index_data_copy_set(format_, count_, indices_));
   }

   Evas_3D_Index_Format index_format_get() const
   {
      Evas_3D_Index_Format _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_mesh_index_format_get());
      return _tmp_ret;
   }

   int index_count_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_mesh_index_count_get());
      return _tmp_ret;
   }

   void * index_data_map() const
   {
      void * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_mesh_index_data_map());
      return _tmp_ret;
   }

   void index_data_unmap() const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_index_data_unmap());
   }

   /// @param frame The number of the key frame to be added.
   ///
   void frame_add(int frame_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_frame_add(frame_));
   }

   /// @param frame The number of the key frame to be added.
   ///
   void frame_del(int frame_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_frame_del(frame_));
   }

   /// @brief Set the vertex count of the given mesh.
   ///
   /// Each key frame should have same vertex count to be properly interpolated.
   /// Key frames have their own vertex data and the data should have more vertices
   /// than the mesh's vertex count.
   ///
   /// Default vertex count is 0.
   ///
   /// @ingroup Evas_3D_Mesh
   ///
   /// @param count Vertex count.
   ///
   void vertex_count_set(unsigned int count_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_vertex_count_set(count_));
   }

   /// @brief Get the vertex count of the given mesh.
   ///
   /// @see evas_3d_mesh_vertex_count_set()
   ///
   /// @ingroup Evas_3D_Mesh
   ///
   int vertex_count_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_mesh_vertex_count_get());
      return _tmp_ret;
   }

   /// @param r The red component of the fog color.
   /// @param g The green component of the fog color.
   /// @param b The blue component of the fog color.
   /// @param a The transparency of fog.
   ///
   void fog_color_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_fog_color_set(r_, g_, b_, a_));
   }

   /// @param[out] r Pointer to receive red component of the fog color.
   /// @param[out] g Pointer to receive green component of the fog color.
   /// @param[out] b Pointer to receive blue component of the fog color.
   /// @param[out] a Pointer to receive transparency of fog.
   ///
   void fog_color_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_fog_color_get(r_, g_, b_, a_));
   }

   /// @param enabled The red component of the fog color.
   ///
   void fog_enable_set(bool enabled_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_mesh_fog_enable_set(efl::eolian::to_c(enabled_)));
   }

   bool fog_enable_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_mesh_fog_enable_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   static Eo_Class const* _eo_class()
   {
      return(EVAS_3D_MESH_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_ref(EVAS_3D_MESH_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _evas_3d_mesh_update_notify_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->update_notify();
}

template <typename T>
void _evas_3d_mesh_change_notify_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_State state_, Evas_3D_Object * ref_)
{
   static_cast<T*>(self->this_)->change_notify(state_, ref_);
}

template <typename T>
Evas_3D_Shade_Mode _evas_3d_mesh_shade_mode_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->shade_mode_get();
}

template <typename T>
void _evas_3d_mesh_shade_mode_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Shade_Mode mode_)
{
   static_cast<T*>(self->this_)->shade_mode_set(mode_);
}

template <typename T>
Evas_3D_Material * _evas_3d_mesh_frame_material_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int frame_)
{
   return static_cast<T*>(self->this_)->frame_material_get(frame_);
}

template <typename T>
void _evas_3d_mesh_frame_material_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int frame_, Evas_3D_Material * material_)
{
   static_cast<T*>(self->this_)->frame_material_set(frame_, material_);
}

template <typename T>
Evas_3D_Vertex_Assembly _evas_3d_mesh_vertex_assembly_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->vertex_assembly_get();
}

template <typename T>
void _evas_3d_mesh_vertex_assembly_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Vertex_Assembly assembly_)
{
   static_cast<T*>(self->this_)->vertex_assembly_set(assembly_);
}

template <typename T>
void _evas_3d_mesh_file_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Mesh_File_Type type_, const char * file_, const char * key_)
{
   static_cast<T*>(self->this_)->file_set(type_, efl::eolian::to_cxx<std::string>(file_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(key_, std::tuple<std::false_type>()));
}

template <typename T>
void _evas_3d_mesh_save_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Mesh_File_Type type_, const char * file_, const char * key_)
{
   static_cast<T*>(self->this_)->save(type_, efl::eolian::to_cxx<std::string>(file_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(key_, std::tuple<std::false_type>()));
}

template <typename T>
void _evas_3d_mesh_frame_vertex_data_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_)
{
   static_cast<T*>(self->this_)->frame_vertex_data_set(frame_, attrib_, stride_, data_);
}

template <typename T>
void _evas_3d_mesh_frame_vertex_data_copy_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_)
{
   static_cast<T*>(self->this_)->frame_vertex_data_copy_set(frame_, attrib_, stride_, data_);
}

template <typename T>
void * _evas_3d_mesh_frame_vertex_data_map_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int frame_, Evas_3D_Vertex_Attrib attrib_)
{
   return static_cast<T*>(self->this_)->frame_vertex_data_map(frame_, attrib_);
}

template <typename T>
void _evas_3d_mesh_frame_vertex_data_unmap_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int frame_, Evas_3D_Vertex_Attrib attrib_)
{
   static_cast<T*>(self->this_)->frame_vertex_data_unmap(frame_, attrib_);
}

template <typename T>
int _evas_3d_mesh_frame_vertex_stride_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int frame_, Evas_3D_Vertex_Attrib attrib_)
{
   return static_cast<T*>(self->this_)->frame_vertex_stride_get(frame_, attrib_);
}

template <typename T>
void _evas_3d_mesh_index_data_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Index_Format format_, int count_, const void * indices_)
{
   static_cast<T*>(self->this_)->index_data_set(format_, count_, indices_);
}

template <typename T>
void _evas_3d_mesh_index_data_copy_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Index_Format format_, int count_, const void * indices_)
{
   static_cast<T*>(self->this_)->index_data_copy_set(format_, count_, indices_);
}

template <typename T>
Evas_3D_Index_Format _evas_3d_mesh_index_format_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->index_format_get();
}

template <typename T>
int _evas_3d_mesh_index_count_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->index_count_get();
}

template <typename T>
void * _evas_3d_mesh_index_data_map_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->index_data_map();
}

template <typename T>
void _evas_3d_mesh_index_data_unmap_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->index_data_unmap();
}

template <typename T>
void _evas_3d_mesh_frame_add_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int frame_)
{
   static_cast<T*>(self->this_)->frame_add(frame_);
}

template <typename T>
void _evas_3d_mesh_frame_del_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int frame_)
{
   static_cast<T*>(self->this_)->frame_del(frame_);
}

template <typename T>
void _evas_3d_mesh_vertex_count_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, unsigned int count_)
{
   static_cast<T*>(self->this_)->vertex_count_set(count_);
}

template <typename T>
int _evas_3d_mesh_vertex_count_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->vertex_count_get();
}

template <typename T>
void _evas_3d_mesh_fog_color_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
{
   static_cast<T*>(self->this_)->fog_color_set(r_, g_, b_, a_);
}

template <typename T>
void _evas_3d_mesh_fog_color_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
{
   static_cast<T*>(self->this_)->fog_color_get(r_, g_, b_, a_);
}

template <typename T>
void _evas_3d_mesh_fog_enable_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enabled_)
{
   static_cast<T*>(self->this_)->fog_enable_set(efl::eolian::to_cxx<bool>(enabled_, std::tuple<std::false_type>()));
}

template <typename T>
bool _evas_3d_mesh_fog_enable_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->fog_enable_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_3d_mesh >
{
   template <typename T>
   struct type
   {
      virtual void update_notify()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_update_notify());
      }

      virtual void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_change_notify(state_, ref_));
      }

      virtual Evas_3D_Shade_Mode shade_mode_get()
      {
         Evas_3D_Shade_Mode _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_shade_mode_get());
            return _tmp_ret;
      }

      virtual void shade_mode_set(Evas_3D_Shade_Mode mode_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_shade_mode_set(mode_));
      }

      virtual Evas_3D_Material * frame_material_get(int frame_)
      {
         Evas_3D_Material * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_frame_material_get(frame_));
            return _tmp_ret;
      }

      virtual void frame_material_set(int frame_, Evas_3D_Material * material_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_frame_material_set(frame_, material_));
      }

      virtual Evas_3D_Vertex_Assembly vertex_assembly_get()
      {
         Evas_3D_Vertex_Assembly _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_vertex_assembly_get());
            return _tmp_ret;
      }

      virtual void vertex_assembly_set(Evas_3D_Vertex_Assembly assembly_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_vertex_assembly_set(assembly_));
      }

      virtual void file_set(Evas_3D_Mesh_File_Type type_, std::string file_, std::string key_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_file_set(type_, efl::eolian::to_c(file_), efl::eolian::to_c(key_)));
      }

      virtual void save(Evas_3D_Mesh_File_Type type_, std::string file_, std::string key_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_save(type_, efl::eolian::to_c(file_), efl::eolian::to_c(key_)));
      }

      virtual void frame_vertex_data_set(int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_frame_vertex_data_set(frame_, attrib_, stride_, data_));
      }

      virtual void frame_vertex_data_copy_set(int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_frame_vertex_data_copy_set(frame_, attrib_, stride_, data_));
      }

      virtual void * frame_vertex_data_map(int frame_, Evas_3D_Vertex_Attrib attrib_)
      {
         void * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_frame_vertex_data_map(frame_, attrib_));
            return _tmp_ret;
      }

      virtual void frame_vertex_data_unmap(int frame_, Evas_3D_Vertex_Attrib attrib_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_frame_vertex_data_unmap(frame_, attrib_));
      }

      virtual int frame_vertex_stride_get(int frame_, Evas_3D_Vertex_Attrib attrib_)
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_frame_vertex_stride_get(frame_, attrib_));
            return _tmp_ret;
      }

      virtual void index_data_set(Evas_3D_Index_Format format_, int count_, const void * indices_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_index_data_set(format_, count_, indices_));
      }

      virtual void index_data_copy_set(Evas_3D_Index_Format format_, int count_, const void * indices_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_index_data_copy_set(format_, count_, indices_));
      }

      virtual Evas_3D_Index_Format index_format_get()
      {
         Evas_3D_Index_Format _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_index_format_get());
            return _tmp_ret;
      }

      virtual int index_count_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_index_count_get());
            return _tmp_ret;
      }

      virtual void * index_data_map()
      {
         void * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_index_data_map());
            return _tmp_ret;
      }

      virtual void index_data_unmap()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_index_data_unmap());
      }

      virtual void frame_add(int frame_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_frame_add(frame_));
      }

      virtual void frame_del(int frame_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_frame_del(frame_));
      }

      virtual void vertex_count_set(unsigned int count_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_vertex_count_set(count_));
      }

      virtual int vertex_count_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_vertex_count_get());
            return _tmp_ret;
      }

      virtual void fog_color_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_fog_color_set(r_, g_, b_, a_));
      }

      virtual void fog_color_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_fog_color_get(r_, g_, b_, a_));
      }

      virtual void fog_enable_set(bool enabled_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_fog_enable_set(efl::eolian::to_c(enabled_)));
      }

      virtual bool fog_enable_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_fog_enable_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::evas_3d_mesh >
{
   static const int value = 29;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::evas_3d_mesh>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_update_notify_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_3d_object_update_notify);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_change_notify_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_3d_object_change_notify);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_shade_mode_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_shade_mode_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_shade_mode_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_shade_mode_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_material_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_material_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_material_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_material_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_vertex_assembly_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_vertex_assembly_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_vertex_assembly_set_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_vertex_assembly_set);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_file_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_file_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_save_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_save);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_vertex_data_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_vertex_data_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_vertex_data_copy_set_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_vertex_data_copy_set);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_vertex_data_map_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_vertex_data_map);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_vertex_data_unmap_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_vertex_data_unmap);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_vertex_stride_get_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_vertex_stride_get);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_index_data_set_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_index_data_set);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_index_data_copy_set_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_index_data_copy_set);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   ops[17].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_index_format_get_wrapper<T>);
   ops[17].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_index_format_get);
   ops[17].op = EO_OP_OVERRIDE;
   ops[17].op_type = EO_OP_TYPE_REGULAR;
   ops[17].doc = NULL;

   ops[18].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_index_count_get_wrapper<T>);
   ops[18].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_index_count_get);
   ops[18].op = EO_OP_OVERRIDE;
   ops[18].op_type = EO_OP_TYPE_REGULAR;
   ops[18].doc = NULL;

   ops[19].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_index_data_map_wrapper<T>);
   ops[19].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_index_data_map);
   ops[19].op = EO_OP_OVERRIDE;
   ops[19].op_type = EO_OP_TYPE_REGULAR;
   ops[19].doc = NULL;

   ops[20].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_index_data_unmap_wrapper<T>);
   ops[20].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_index_data_unmap);
   ops[20].op = EO_OP_OVERRIDE;
   ops[20].op_type = EO_OP_TYPE_REGULAR;
   ops[20].doc = NULL;

   ops[21].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_add_wrapper<T>);
   ops[21].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_add);
   ops[21].op = EO_OP_OVERRIDE;
   ops[21].op_type = EO_OP_TYPE_REGULAR;
   ops[21].doc = NULL;

   ops[22].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_del_wrapper<T>);
   ops[22].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_del);
   ops[22].op = EO_OP_OVERRIDE;
   ops[22].op_type = EO_OP_TYPE_REGULAR;
   ops[22].doc = NULL;

   ops[23].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_vertex_count_set_wrapper<T>);
   ops[23].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_vertex_count_set);
   ops[23].op = EO_OP_OVERRIDE;
   ops[23].op_type = EO_OP_TYPE_REGULAR;
   ops[23].doc = NULL;

   ops[24].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_vertex_count_get_wrapper<T>);
   ops[24].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_vertex_count_get);
   ops[24].op = EO_OP_OVERRIDE;
   ops[24].op_type = EO_OP_TYPE_REGULAR;
   ops[24].doc = NULL;

   ops[25].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_fog_color_set_wrapper<T>);
   ops[25].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_fog_color_set);
   ops[25].op = EO_OP_OVERRIDE;
   ops[25].op_type = EO_OP_TYPE_REGULAR;
   ops[25].doc = NULL;

   ops[26].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_fog_color_get_wrapper<T>);
   ops[26].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_fog_color_get);
   ops[26].op = EO_OP_OVERRIDE;
   ops[26].op_type = EO_OP_TYPE_REGULAR;
   ops[26].doc = NULL;

   ops[27].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_fog_enable_set_wrapper<T>);
   ops[27].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_fog_enable_set);
   ops[27].op = EO_OP_OVERRIDE;
   ops[27].op_type = EO_OP_TYPE_REGULAR;
   ops[27].doc = NULL;

   ops[28].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_fog_enable_get_wrapper<T>);
   ops[28].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_fog_enable_get);
   ops[28].op = EO_OP_OVERRIDE;
   ops[28].op_type = EO_OP_TYPE_REGULAR;
   ops[28].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::evas_3d_mesh >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::evas_3d_mesh, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::evas_3d_mesh >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::evas_3d_mesh, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::evas_3d_mesh>
{
   template <typename U>
   struct type
   {
      operator ::evas_3d_mesh() const
      {
         return ::evas_3d_mesh(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void update_notify()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_object_update_notify());
      }

      void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_object_change_notify(state_, ref_));
      }

      Evas_3D_Shade_Mode shade_mode_get()
      {
         Evas_3D_Shade_Mode _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_mesh_shade_mode_get());
            return _tmp_ret;
      }

      void shade_mode_set(Evas_3D_Shade_Mode mode_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_shade_mode_set(mode_));
      }

      Evas_3D_Material * frame_material_get(int frame_)
      {
         Evas_3D_Material * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_mesh_frame_material_get(frame_));
            return _tmp_ret;
      }

      void frame_material_set(int frame_, Evas_3D_Material * material_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_frame_material_set(frame_, material_));
      }

      Evas_3D_Vertex_Assembly vertex_assembly_get()
      {
         Evas_3D_Vertex_Assembly _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_mesh_vertex_assembly_get());
            return _tmp_ret;
      }

      void vertex_assembly_set(Evas_3D_Vertex_Assembly assembly_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_vertex_assembly_set(assembly_));
      }

      void file_set(Evas_3D_Mesh_File_Type type_, std::string file_, std::string key_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_file_set(type_, efl::eolian::to_c(file_), efl::eolian::to_c(key_)));
      }

      void save(Evas_3D_Mesh_File_Type type_, std::string file_, std::string key_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_save(type_, efl::eolian::to_c(file_), efl::eolian::to_c(key_)));
      }

      void frame_vertex_data_set(int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_frame_vertex_data_set(frame_, attrib_, stride_, data_));
      }

      void frame_vertex_data_copy_set(int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_frame_vertex_data_copy_set(frame_, attrib_, stride_, data_));
      }

      void * frame_vertex_data_map(int frame_, Evas_3D_Vertex_Attrib attrib_)
      {
         void * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_mesh_frame_vertex_data_map(frame_, attrib_));
            return _tmp_ret;
      }

      void frame_vertex_data_unmap(int frame_, Evas_3D_Vertex_Attrib attrib_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_frame_vertex_data_unmap(frame_, attrib_));
      }

      int frame_vertex_stride_get(int frame_, Evas_3D_Vertex_Attrib attrib_)
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_mesh_frame_vertex_stride_get(frame_, attrib_));
            return _tmp_ret;
      }

      void index_data_set(Evas_3D_Index_Format format_, int count_, const void * indices_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_index_data_set(format_, count_, indices_));
      }

      void index_data_copy_set(Evas_3D_Index_Format format_, int count_, const void * indices_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_index_data_copy_set(format_, count_, indices_));
      }

      Evas_3D_Index_Format index_format_get()
      {
         Evas_3D_Index_Format _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_mesh_index_format_get());
            return _tmp_ret;
      }

      int index_count_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_mesh_index_count_get());
            return _tmp_ret;
      }

      void * index_data_map()
      {
         void * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_mesh_index_data_map());
            return _tmp_ret;
      }

      void index_data_unmap()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_index_data_unmap());
      }

      void frame_add(int frame_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_frame_add(frame_));
      }

      void frame_del(int frame_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_frame_del(frame_));
      }

      void vertex_count_set(unsigned int count_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_vertex_count_set(count_));
      }

      int vertex_count_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_mesh_vertex_count_get());
            return _tmp_ret;
      }

      void fog_color_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_fog_color_set(r_, g_, b_, a_));
      }

      void fog_color_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_fog_color_get(r_, g_, b_, a_));
      }

      void fog_enable_set(bool enabled_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_mesh_fog_enable_set(efl::eolian::to_c(enabled_)));
      }

      bool fog_enable_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_mesh_fog_enable_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::evas_3d_mesh>)
{
   return (EVAS_3D_MESH_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_3D_MESH_HH

